#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);

#define NUMFLAKES 10
#define XPOS 0
#define YPOS 1
#define DELTAY 2


#define LOGO16_GLCD_HEIGHT 16 
#define LOGO16_GLCD_WIDTH  16 
static const unsigned char PROGMEM logo16_glcd_bmp[] =
{ B00000000, B11000000,
  B00000001, B11000000,
  B00000001, B11000000,
  B00000011, B11100000,
  B11110011, B11100000,
  B11111110, B11111000,
  B01111110, B11111111,
  B00110011, B10011111,
  B00011111, B11111100,
  B00001101, B01110000,
  B00011011, B10100000,
  B00111111, B11100000,
  B00111111, B11110000,
  B01111100, B11110000,
  B01110000, B01110000,
  B00000000, B00110000 };

#if (SSD1306_LCDHEIGHT != 32)
#error("Height incorrect, please fix Adafruit_SSD1306.h!");
#endif
int swb = PIN_PD1,swg = PIN_PD5,swy = PIN_PD6;
int led1 = PIN_PB0, led2 = PIN_PB1, led3 = PIN_PB2, led4 = PIN_PB3, led5 = PIN_PB4, led6 = PIN_PB5, led7 = PIN_PC0, led8 = PIN_PC1, led9 = PIN_PC2, led10 = PIN_PC3;
int bcount = 0;
int point = 0;
int set = 0;
int ms = 59;
int s = 9;
unsigned long timefor1;
unsigned long timefor2;
unsigned long star;

void setup() {
  Serial.begin(9600); //opens portsets ,rate to 9600 bps
  pinMode(swb,INPUT_PULLUP);
  pinMode(swg,INPUT_PULLUP);
  pinMode(swy,INPUT_PULLUP);
  pinMode(led1,OUTPUT);
  pinMode(led2,OUTPUT);
  pinMode(led3,OUTPUT);
  pinMode(led4,OUTPUT);
  pinMode(led5,OUTPUT);
  pinMode(led6,OUTPUT);
  pinMode(led7,OUTPUT);
  pinMode(led8,OUTPUT);
  pinMode(led9,OUTPUT);
  pinMode(led10,OUTPUT);
  display.begin();
  display.clearDisplay();
  start();
  display.clearDisplay();
  timefor1 = millis();
  timefor2 = millis();
  star = millis();
}

void loop() {
  int bb = digitalRead(swb);
  int bg = digitalRead(swg);
  int by = digitalRead(swy);
  display.setTextSize(4);
  display.setTextColor(WHITE);
  if((millis()-timefor2) >= 1 && (set == 3 || set == 2 || set == 1)){
    if((millis()-timefor1) >= 1 && ms >= 0 && s >= 0){
        display.setCursor(7,7);
        if(s>=10){
          display.print(s);
          if(ms>=10){
            display.print(":");
            display.print(ms);
          }
          else if(ms == 0){
            display.print(":0");
            display.print(ms);
            ms = 59;
            s--;
          }
          else{
            display.print(":0");
            display.print(ms);
          } 
          display.display();
          timefor2 = millis();
          ms--; 
        }
        else{
          display.print("0");
          display.print(s);
          if(ms>=10){
            display.print(":");
            display.print(ms);
          }
          else if(ms == 0){
            if(s > 0){
              display.print(":0");
              display.print(ms);
              ms = 59;
              s--;
            }
            else {
              display.clearDisplay();
              endgame();
              set = 0;
              display.stopscroll();
              start();
            }
          }
          else{
            display.print(":0");
            display.print(ms);
          }
          display.display();
          timefor2 = millis();
          ms--;
        }
      timefor1 = millis();
      display.clearDisplay();
      }
    }
  if(bg == 1 && set == 0){
    ;
  }
  if(bg == 0 && set == 0 && by == 1){
    point = 0;
    reset();
    count();
    s = 11;
    ms = 59;
    set = 3;
  }
  if(bb == 0){
    bcount = 1;
  }
  if(by == 0 && bcount == 1 && bb == 1 && set != 0){
      point += 1;
      bcount = 0;
      if(point >= 3 && point < 7){
        digitalWrite(led1,HIGH); 
      }
      else if(point >= 7 && point < 11){
        digitalWrite(led2,HIGH);
      }
      else if(point >= 11  && point < 15){
        digitalWrite(led3,HIGH); 
      }
      else if(point >= 15 && point < 23){
        digitalWrite(led4,HIGH);
      }
      else if(point >= 23 && point < 30){
        digitalWrite(led5,HIGH);
      }
      else if(point >= 30 && point < 37){
        digitalWrite(led6,HIGH);
      }
      else if(point >= 37 && point < 45){
        digitalWrite(led7,HIGH);
      }
      else if(point >= 45 && point < 53){
        digitalWrite(led8,HIGH);
      }
      else if(point >= 53 && point < 63){
        digitalWrite(led9,HIGH);
      }
      else if(point >= 63){
        digitalWrite(led10,HIGH);
        if(set == 3){
           secondset();
        } 
        else if(set == 2){
           finalset();
        }
        else if(set == 1){
           win();
           reset();
           set = 0;
           start();
        }
      }
   }
   if(by == 0 && bg == 0){
    display.clearDisplay();
    display.display();
    reset(); 
    set = 0;
   }
}

void start(void){
  display.setTextSize(4);
  display.setTextColor(WHITE);
  display.setCursor(7,7);
  display.print("START");
  display.display();
}

void win(void){
  delay(6000);
  display.clearDisplay();
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(1,10);
  display.print("YOU WIN");
  display.display();
  delay(1000);
  testdrawbitmap(logo16_glcd_bmp, LOGO16_GLCD_HEIGHT, LOGO16_GLCD_WIDTH, star);
  display.clearDisplay();
}

void count(void){
  display.clearDisplay();
  display.setTextSize(4);
  display.setCursor(55,7);
  display.print("3");
  display.display();
  delay(1000);
  display.clearDisplay();
  display.setCursor(55,7);
  display.print("2");
  display.display();
  delay(1000); 
  display.clearDisplay();
  display.setCursor(55,7);
  display.print("1");
  display.display();
  delay(1000);
  display.clearDisplay(); 
}

void endgame(void){
  display.setTextSize(2);
  display.setCursor(7,14);
  display.print("GAME OVER");
  display.display();
  display.startscrollleft(0x00, 0x0F);
  delay(8000);
  reset();
  display.clearDisplay();
}

void reset(void){
  digitalWrite(led1,LOW);
  digitalWrite(led2,LOW);
  digitalWrite(led3,LOW);
  digitalWrite(led4,LOW);
  digitalWrite(led5,LOW);
  digitalWrite(led6,LOW);
  digitalWrite(led7,LOW);
  digitalWrite(led8,LOW);
  digitalWrite(led9,LOW);
  digitalWrite(led10,LOW);
}

void secondset(void){
  display.setTextSize(4);
  display.setCursor(19,7);
  display.print("PASS");
  display.display();
  delay(4000);
  display.clearDisplay();
  display.setTextSize(3);
  display.setCursor(2,10);
  display.print("STATE 2");
  display.display();
  delay(4000);
  display.clearDisplay();
  point = 0;
  reset();
  s = 9;
  ms = 59;
  set = 2; 
  count();
}

void finalset(void){
  display.setTextSize(4);
  display.setCursor(19,7);
  display.print("PASS");
  display.display();
  delay(4000);
  display.clearDisplay();
  display.display();
  display.setTextSize(2);
  display.setCursor(4,14);
  display.print("FINALSTATE");
  display.display();
  delay(4000);
  display.clearDisplay();
  point = 0;
  reset();
  s = 7;
  ms = 59;
  set = 1; 
  count();
}

void testdrawbitmap(const uint8_t *bitmap, uint8_t w, uint8_t h,unsigned long star) {
  uint8_t icons[NUMFLAKES][3];
 
  // initialize
  for (uint8_t f=0; f< NUMFLAKES; f++) {
    icons[f][XPOS] = random(display.width());
    icons[f][YPOS] = 0;
    icons[f][DELTAY] = random(5) + 1;
    
    Serial.print("x: ");
    Serial.print(icons[f][XPOS], DEC);
    Serial.print(" y: ");
    Serial.print(icons[f][YPOS], DEC);
    Serial.print(" dy: ");
    Serial.println(icons[f][DELTAY], DEC);
  }
  star = millis();
  while (millis()-star <= 7000) {
    // draw each icon
    for (uint8_t f=0; f< NUMFLAKES; f++) {
      display.drawBitmap(icons[f][XPOS], icons[f][YPOS], bitmap, w, h, WHITE);
    }
    display.display();
    delay(200);
    
    // then erase it + move it
    for (uint8_t f=0; f< NUMFLAKES; f++) {
      display.drawBitmap(icons[f][XPOS], icons[f][YPOS], bitmap, w, h, BLACK);
      // move it
      icons[f][YPOS] += icons[f][DELTAY];
      // if its gone, reinit
      if (icons[f][YPOS] > display.height()) {
        icons[f][XPOS] = random(display.width());
        icons[f][YPOS] = 0;
        icons[f][DELTAY] = random(5) + 1;
      }
    }
   }
}
